Unit uGroundspeak;

{$MODE objfpc}{$H+}

Interface

Uses
  Classes, SysUtils, httpsend;

Type

  { TGroundspeak }

  TGroundspeak = Class
  private

    fHTTP: THTTPSend;
  public
    ProxyHost: String;
    ProxyPass: String;
    ProxyPort: String;
    ProxyUser: String;
    Constructor Create;
    Destructor Destroy; override;

    Function Login(UserName, Password: String): Boolean;
  End;

Implementation

Uses
  ssl_openssl, synautil, dialogs, unit1, uhtmlparser; // Debug to be removed

{ TGroundspeak }

Constructor TGroundspeak.Create;
Begin
  ProxyUser := '';
  ProxyPass := '';
  ProxyHost := '';
  ProxyPort := '';
  fHTTP := THTTPSend.Create;
End;

Destructor TGroundspeak.Destroy;
Begin
  fHTTP.free;
End;

Function TGroundspeak.Login(UserName, Password: String): Boolean;
Var
  tmps: TStringlist;
  __RequestVerificationToken, s: String;
  html: Phtml;
Begin
  result := false;
  fHTTP.Cookies.Clear;
  If ProxyHost <> '' Then Begin
    fHTTP.ProxyHost := ProxyHost;
    fHTTP.ProxyPass := ProxyPass;
    fHTTP.ProxyPort := ProxyPort;
    fHTTP.ProxyUser := ProxyUser;
  End;
  Result := fHTTP.HTTPMethod('GET', 'https://www.geocaching.com/account/login');
  If Not Result Then Begin // Die einlog HP konnte nicht geöffnet werden -> Anzeigen was geht ..
    showmessage(
      'HTTP.ResultCode :' + inttostr(fhttp.ResultCode) + ' ; ' + fhttp.ResultString + LineEnding +
      'HTTP.Sock.LastError :' + inttostr(fHTTP.Sock.LastError) + ' ; ' + fHTTP.Sock.LastErrorDesc + LineEnding +
      'HTTP.Sock.SSL.LastError :' + inttostr(fHTTP.Sock.SSL.LastError) + ' ; ' + fHTTP.Sock.SSL.LastErrorDesc);
    fHTTP.free;
    exit;
  End;
  // Weiter mit dem Laden des Contents
  tmps := TStringlist.Create;
  tmps.LoadFromStream(fHTTP.Document);
  s := tmps.Text;
  tmps.free;
  html := HTMLStringToHTML(s);
  If Not assigned(html) Then showmessage('Damn, beim Parsing');
  // Todo : Eine geeignete Suchfunktion implementieren, die das dann Richtig findet.
  __RequestVerificationToken := html^.SubElements[0]^.Attributes[2].Value;

  // {

  So hier ist, wenn auch Gefaked der HTML Relevante Teil In "html" und der Token In __RequestVerificationToken

  Wie baut man den Request zusammen und sendet diesen ?
    // }

  FreeHTML(html);
  form1.Memo1.Text := s;
End;

End.

