Unit Unit1;

{$MODE objfpc}{$H+}

Interface

Uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  uGroundspeak;

Type

  { TForm1 }

  TForm1 = Class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Memo1: TMemo;
    Procedure Button1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    Procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    fgc: TGroundspeak;
  public
    { public declarations }
  End;

Var
  Form1: TForm1;

Implementation

{$R *.lfm}

{ TForm1 }

Procedure TForm1.FormCreate(Sender: TObject);
Begin
  fgc := TGroundspeak.Create;
  edit1.text := '';
  edit2.text := '';
End;

Procedure TForm1.Button1Click(Sender: TObject);
Begin
  If fgc.Login(Edit1.text, Edit2.text) Then Begin
    caption := 'eingeloggt';
  End
  Else Begin
    caption := 'fehler beim eingeloggen';
  End;
End;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  fgc.free;
end;

End.

